% Copyright (c) 2014-2015, Leonid Torgovitski
% All rights reserved. 

function [Y] = add_change(E,model) 
             
%%% READ ALL PARAMETERS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n       =   model.n;   
p       =   model.p;
u       =   model.u; 
cp_rnd  =   model.cp_rnd;
            
            
            Y = E;
            if cp_rnd > 0
                
                %%% ADD A RANDOM CHANGE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
                urnd = u + cp_rnd*sign(unidrnd(2,1,p)-1.5);
                
                for ip=1:p
                    Y((urnd(ip)+1):n,ip) = E((urnd(ip)+1):n,ip) + ones(n-urnd(ip),1);
                end
                
            else   
                %%% ADD A NON-RANDOM CHANGE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                Y((u+1):n,:) = E((u+1):n,:) + sqrt(model.delta2_k)*ones(n-u,p);
            end 
end


